# SALD Dataset and Queries 

## Dataset

The neuroscience dataset, SALD, obtained from [1], represents MRI data, including
200 million data series of size 128. The dataset is z-normalized.

## Queries

### Lernaean Hydra 1 [2]: queries_ctrl100_sald_len128_znorm.bin
This is a set of 100 queries generated by adding progressively larger amounts of
noise to data series extracted from the dataset. 

### Hercules [3]: queries_hard*p_deep1b_len96_znorm_bin
This is a set of 100 queries selected randomly from the original dataset and
perturbed using different levels of Guassian noise ($\mu$ = 0, $\sigma^2$ = 0.01-0.1),
in order to create queries of varying difficulty. The queries are labeled with the value
of $\sigma^2$ expressed as a percentage 1%-10%.

All queries are z-normalized.

## Reference
[1] S. University. Southwest University Adult Lifespan Dataset (SALD).
    http://fcon_1000.projects.nitrc.org/indi/retro/sald.html?utm_source=
    newsletter&utm_medium=email&utm_content=See%20Data&utm_campaign=indi-1, 2018.

[2] K. Echihabi, K. Zoumpatianos, T. Palpanas, and H. Benbrahim. The Lernaean
    Hydra of Data Series Similarity Search: An Experimental Evaluation of the
    State of the Art. PVLDB, 12(2), 2018.

[3] K. Echihabi, K. Zoumpatianos, T. Palpanas, P. Fatourou, and H. Benbrahim, 
    Hercules Against Data Series Similarity Search. PVLDB, 2022.
